/*
  MM5 file reader for C
  written by Shigenori OTSUKA 
  from 2006.12.20         
  last midified 2008.9.3
*/

#include "narray.h"

/* ruby 1.6 compatibility */
#ifndef StringValuePtr
#define StringValuePtr(v) STR2CSTR(v)
#endif

static void rb_mm5_free_mm5(struct MM5_STRUCT *mm5struct);
#ifdef HAVE_RB_DEFINE_ALLOC_FUNC
static VALUE rb_mm5_make_mm5();
static VALUE rb_mm5_initialize(VALUE self);
#else
static VALUE rb_mm5_new_ruby16();
#endif
static VALUE rb_mm5_singleton_open(int argc, VALUE argv[], VALUE self);
static VALUE rb_mm5_open(int argc, VALUE argv[], VALUE self);
static VALUE rb_mm5_close(VALUE self);
static VALUE rb_mm5_get_shape(VALUE self, VALUE varname, VALUE time);
static VALUE rb_mm5_staggering(VALUE self, VALUE varname, VALUE time);
static VALUE rb_mm5_ordering(VALUE self, VALUE varname, VALUE time);
static VALUE rb_mm5_read(VALUE self, VALUE varname, VALUE time);
static VALUE rb_mm5_bhi(VALUE self,VALUE vi,VALUE vj);
static VALUE rb_mm5_bhr(VALUE self,VALUE vi,VALUE vj);
static VALUE rb_mm5_ntime(VALUE self);
static VALUE rb_mm5_xtimes(VALUE self);
static VALUE rb_mm5_var_names(VALUE self);
static VALUE rb_mm5_overwrite(VALUE self, VALUE varname, VALUE time, VALUE data);
void Init_mm5_io_raw();
